/********************************** (C) COPYRIGHT *******************************
* File Name          : USBH_KM.C
* Author             : WCH
* Version            : V1.5
* Date               : 2018/08/01
* Description        :
 USB host example for CH559, start USB device under DP/DM and HP/HM port
 USBӦ,ʼöUSB˿ӵ豸,ͬʱ֧2USB豸,֧һⲿHUB,
 ԲUSBHUB,HID
 ֧U̲ҪỤο
*******************************************************************************/
#include <CH559.H>
#include <stdio.h>
#include <string.h>
#pragma  NOAREGS
// ӳ򷵻״̬
#define ERR_SUCCESS         0x00    // ɹ
#define ERR_USB_CONNECT     0x15    /* ⵽USB豸¼,Ѿ */
#define ERR_USB_DISCON      0x16    /* ⵽USB豸Ͽ¼,ѾϿ */
#define ERR_USB_BUF_OVER    0x17    /* USB̫໺ */
#define ERR_USB_DISK_ERR    0x1F    /* USB洢ʧ,ڳʼʱUSB洢֧,ڶдпǴ𻵻ѾϿ */
#define ERR_USB_TRANSFER    0x20    /* NAK/STALLȸ0x20~0x2F */
#define ERR_USB_OVER_IF     0x30    /* 豸ӿ4 */
#define ERR_USB_UNSUPPORT   0xFB    /*ֵ֧USB豸*/
#define ERR_USB_UNKNOWN     0xFE    /*豸*/
/*ȡ豸*/
UINT8C  SetupGetDevDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_DEVICE, 0x00, 0x00, sizeof( USB_DEV_DESCR ), 0x00 };
/*ȡ*/
UINT8C  SetupGetCfgDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_CONFIG, 0x00, 0x00, 0x04, 0x00 };
/*USBַ*/
UINT8C  SetupSetUsbAddr[] = { USB_REQ_TYP_OUT, USB_SET_ADDRESS, USB_DEVICE_ADDR, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*USB*/
UINT8C  SetupSetUsbConfig[] = { USB_REQ_TYP_OUT, USB_SET_CONFIGURATION, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*USB IDLE*/
UINT8C  SetupSetUsbIDLE[] = { 0x21, HID_SET_IDLE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*USBӿ*/
UINT8C  SetupSetUsbInterface[] = { USB_REQ_RECIP_INTERF, USB_SET_INTERFACE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*˵STALL*/
UINT8C  SetupClrEndpStall[] = { USB_REQ_TYP_OUT | USB_REQ_RECIP_ENDP, USB_CLEAR_FEATURE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
/*ȡHID豸*/
UINT8C  SetupGetHIDDevReport[] = { 0x81, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_REPORT, 0x00, 0x00, 0x41, 0x00 };
/* set usb device report*/
UINT8C  SetupSetReport[] = {USB_DESCR_TYP_HID,0x09,0x00,0x02,0x00,0x00,0x01,0x00}; 
UINT8X  UsbDevEndp0Size;              /* USB豸Ķ˵0ߴ */
/*USB豸Ϣ,CH559֧2豸*/
#define ROOT_DEV_DISCONNECT     0
#define ROOT_DEV_CONNECTED      1
#define ROOT_DEV_FAILED         2
#define ROOT_DEV_SUCCESS        3
#define DEV_TYPE_KEYBOARD   ( USB_DEV_CLASS_HID | 0x20 )
#define DEV_TYPE_MOUSE      ( USB_DEV_CLASS_HID | 0x30 )
UINT8 ReportData = 0;
#define  HUB_INTERFACE_COUNT        4
#define  GLOB_USAGE_PAGE_DEF  		0X05	  // Unsigned integer specifying the current Usage Page.
#define  GLOB_USAGE_PAGE_DESKTOP    0X01	  // generic desktop
#define  LOCAL_USAGE_DEF	      	0X09	  // Usage index for an item usage; represents a suggested usage for the item or collection. 
#define  LOCAL_USAGE_MOUSE     	    0X02	  // MOUSE
#define  LOCAL_USAGE_KEY     		0X06	  // KEY

#define  DEBUG 1

struct _RootHubDev
{
    UINT8   DeviceStatus;           // 豸״̬,0-豸,1-豸δʼ,2-豸ʼöʧ,3-豸ҳʼöٳɹ
    UINT8   DeviceAddress;          // 豸USBַ
    UINT8   DeviceSpeed;            // 0Ϊ,0Ϊȫ
    UINT8   DeviceType;             // 豸
    UINT8   InfCnt;                 // 豸ӿ
    struct interface{
        UINT16  DescrLen;          // hid descripor len
        UINT8   InAddr;            // in endpoint address
        UINT8   OutAddr;           // in endpoint address
    	UINT8   DeviceType;        // device type 
        UINT8   WaitUSB_IN_Interval;      
    }Interface[HUB_INTERFACE_COUNT];	
} xdata RootHubDev[2];
UINT8X  RxBuffer[ MAX_PACKET_SIZE ] _at_ 0x0000 ;  // IN, must even address
UINT8X  TxBuffer[ MAX_PACKET_SIZE*3 ] _at_ 0x0040 ;  // OUT, must even address
#define pSetupReq   ((PXUSB_SETUP_REQ)TxBuffer)
bit     RootHubId;                 // ǰڲroot-hub˿ں:0=HUB0,1=HUB1
bit     FoundNewDev;                   

UINT16X  T0Count[2][HUB_INTERFACE_COUNT];    //T0λms
#pragma NOAREGS
#define WAIT_USB_TOUT_200US     200  // ȴUSBжϳʱʱ200uS@Fsys=12MHz
#define WAIT_USB_IN_COUNT     0x2EE0  // ȴUSBжϳʱʱ200uS@Fsys=12MHz

void    mDelayuS( UINT16 n );                          // uSΪλʱ
void    mDelaymS( UINT16 n );                          // mSΪλʱ
void    DisableRootHubPort( UINT8 RootHubIndex );      // رָROOT-HUB˿,ʵӲѾԶر,˴ֻһЩṹ״̬
UINT8   AnalyzeRootHub( void );                        // ROOT-HUB״̬,ROOT-HUB˿ڵ豸¼
// ERR_SUCCESSΪû,ERR_USB_CONNECTΪ⵽,ERR_USB_DISCONΪ⵽Ͽ
void    SetHostUsbAddr( UINT8 addr );                  // USBǰUSB豸ַ
void    SetUsbSpeed( UINT8 FullSpeed );                // õǰUSBٶ
UINT8   ResetRootHubPort( UINT8 RootHubIndex );        // ⵽豸,λӦ˿ڵ,Ϊö豸׼,ΪĬΪȫ
UINT8   EnableRootHubPort( UINT8 RootHubIndex );       // ʹROOT-HUB˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ
void    SelectHubPort( UINT8 RootHubIndex, UINT8 HubPortIndex );// HubPortIndex=0ѡָROOT-HUB˿,ѡָROOT-HUB˿ڵⲿHUBָ˿
UINT8   WaitUSB_Interrupt( void );                     // ȴUSBж
// CH559,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
UINT8   USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT16 timeout );  // endp_pid: 4λtoken_pid, 4λǶ˵ַ
UINT8   HostCtrlTransfer( PUINT8 DataBuf, PUINT8 RetLen );  // ִпƴ,8ֽpSetupReq,DataBufΪѡշ
// Ҫպͷ,ôDataBufָЧڴź,ʵʳɹշܳȷرReqLenָֽڱ
void    CopySetupReqPkg( PUINT8C pReqPkt );            // ƿƴ
UINT8   CtrlGetDeviceDescr( void );                    // ȡ豸,TxBuffer
UINT8   CtrlGetConfigDescr( void );                    // ȡ,TxBuffer
UINT8   CtrlSetUsbAddress( UINT8 addr );               // USB豸ַ
UINT8   CtrlSetUsbConfig( UINT8 cfg );                 // USB豸
UINT8   CtrlSetUsbIntercace( UINT8 cfg );              // USB豸ӿ
UINT8   CtrlClearEndpStall( UINT8 endp );              // ˵STALL
UINT8   AnalyzeHidIntEndp( PUINT8X buf );              // зHIDж϶˵ĵַ
UINT8   InitRootDevice( UINT8 RootHubIndex );          // ʼָROOT-HUB˿ڵUSB豸
UINT16  SearchTypeDevice( UINT8 type );                // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں,˿ںΪ0xFFFFδ
// 8λΪROOT-HUB˿ں,8λΪⲿHUBĶ˿ں,8λΪ0豸ֱROOT-HUB˿
void    mInitSTDIO( void );                            // Ϊprintfgetkeyʼ
void    InitUSB_Host( void );                          // ʼUSB
//#define   FREQ_SYS    12000000                       // ϵͳƵ12MHz

#define T0_START 1
#define T0_STOP 0

#define mTimer0ClkFsys( ) (T2MOD |= bTMR_CLK | bT0_CLK)                     //ʱ,ʱ=Fsys
//CH559 Timer0 ʼ(SS=1)/(SS=0)
#define mTimer0RunCTL( SS ) (TR0 = SS ? T0_START : T0_STOP)
/*******************************************************************************
* Function Name  : mTimer0ModSetup(UINT8 mode)
* Description    : CH559ʱ0ģʽ0
* Input          : UINT8 mode,Timer0ģʽѡ
                   0ģʽ013λʱTL0ĸ3λЧ
                   1ģʽ116λʱ
                   2ģʽ28λԶװʱ
                   3ģʽ38λʱ
* Output         : None
* Return         : None
*******************************************************************************/
void mTimer0ModSetup(UINT8 mode)
{
    TMOD &= 0xf0;
    TMOD |= mode; 
}

/*******************************************************************************
* Function Name  : mTimer0SetData(UINT16 dat)
* Description    : CH559Timer0 TH0TL0ֵ
* Input          : UINT16 dat;ʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void mTimer0SetData(UINT16 dat)
{
    UINT16 tmp;
    tmp = 65536 - dat;	
    TL0 = tmp & 0xff;
    TH0 = (tmp>>8) & 0xff;
}

/*******************************************************************************
* Function Name  : mTimer0Interrupt()
* Description    : CH559ʱ0ʱжϴ
*******************************************************************************/
void	mTimer0Interrupt( void ) //interrupt INT_NO_TMR0 using 1                //timer0жϷ,ʹüĴ1
{                                                                             //ʽ3ʱTH0ʹTimer1жԴ
    UINT8 i;
    if(TF0)
    {					
      CAP1 = ~CAP1;			
      mTimer0SetData(WAIT_USB_IN_COUNT);                                     //Զطʽ¸TH0TL0ֵ  
      for(i=0;i<HUB_INTERFACE_COUNT;i++)			
      {
        T0Count[0][i]++;				
        T0Count[1][i]++;	
      }
      TF0 = 0;			
    }
}

/*******************************************************************************
* Function Name  : mDelayus(UNIT16 n)
* Description    : usʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/
void    mDelayuS( UINT16 n )                           // uSΪλʱ
{
    while ( n )                                        // total = 12~13 Fsys cycles, 1uS @Fsys=12MHz
    {
        ++ SAFE_MOD;                                   // 2 Fsys cycles, for higher Fsys, add operation here
#ifdef  FREQ_SYS
#if     FREQ_SYS >= 14000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 16000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 18000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 20000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 22000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 24000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 26000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 28000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 30000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 32000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 34000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 36000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 38000000
        ++ SAFE_MOD;
#endif
#if     FREQ_SYS >= 40000000
        ++ SAFE_MOD;
#endif
#endif
        -- n;
    }
}
/*******************************************************************************
* Function Name  : mDelayms(UNIT16 n)
* Description    : msʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/
void    mDelaymS( UINT16 n )                              // mSΪλʱ
{
    while ( n )
    {
        mDelayuS( 1000 );
        -- n;
    }
}
/*******************************************************************************
* Function Name  : DisableRootHubPort(UINT8 RootHubIndex)
* Description    : رHUB˿
* Input          : UINT8 RootHubIndex ָROOT_HUB
* Output         : None
* Return         : None
*******************************************************************************/
void    DisableRootHubPort( UINT8 RootHubIndex )          // رָROOT-HUB˿,ʵӲѾԶر,˴ֻһЩṹ״̬
{
    RootHubDev[ RootHubIndex ].DeviceStatus = ROOT_DEV_DISCONNECT;
    RootHubDev[ RootHubIndex ].DeviceAddress = 0x00;
    if ( RootHubIndex == 1 )
    {
        UHUB1_CTRL = 0x00;                                // йHUB1Ŀ,ʵϲҪ
    }
    else
    {
        UHUB0_CTRL = 0x00;                                // йHUB0Ŀ,ʵϲҪ
    }
}
/*******************************************************************************
* Function Name  : AnalyzeRootHub(void)
* Description    : ROOT-HUB״̬,ROOT-HUB˿ڵ豸¼
                   豸γ,еDisableRootHubPort(),˿ڹر,¼,Ӧ˿ڵ״̬λ
* Input          : None
* Output         : None
* Return         : ERR_SUCCESSΪû,ERR_USB_CONNECTΪ⵽,ERR_USB_DISCONΪ⵽Ͽ
*******************************************************************************/
UINT8   AnalyzeRootHub( void )
{
    UINT8   s;
    s = ERR_SUCCESS;
    if ( USB_HUB_ST & bUHS_H0_ATTACH )                         // 豸ڣHUB0
    {
        if ( RootHubDev[0].DeviceStatus == ROOT_DEV_DISCONNECT // ⵽豸
                || ( UHUB0_CTRL & bUH_PORT_EN ) == 0x00 )      // ⵽豸,δ,˵Ǹղ
        {
            DisableRootHubPort( 0 );                           // رն˿
//          RootHubDev[0].DeviceSpeed = USB_HUB_ST & bUHS_DM_LEVEL ? 0 : 1;
            RootHubDev[0].DeviceStatus = ROOT_DEV_CONNECTED;   //ӱ־
            printf( "HUB 0 dev in\n" );
            s = ERR_USB_CONNECT;
        }
    }
    else if ( RootHubDev[0].DeviceStatus >= ROOT_DEV_CONNECTED )//⵽豸γ
    {
        DisableRootHubPort( 0 );                               // رն˿
        printf( "HUB 0 dev out\n" );
        //UH_SETUP &= ~bUH_SOF_EN;
        if ( s == ERR_SUCCESS )
        {
            s = ERR_USB_DISCON;                                //豸Ͽ־
        }
    }
    if ( USB_HUB_ST & bUHS_H1_ATTACH )                         // 豸ڣHUB1
    {
        if ( RootHubDev[1].DeviceStatus == ROOT_DEV_DISCONNECT // ⵽豸
                || ( UHUB1_CTRL & bUH_PORT_EN ) == 0x00 )      // ⵽豸,δ,˵Ǹղ
        {
            DisableRootHubPort( 1 );                           // رն˿
//          RootHubDev[1].DeviceSpeed = USB_HUB_ST & bUHS_HM_LEVEL ? 0 : 1;
            RootHubDev[1].DeviceStatus = ROOT_DEV_CONNECTED;   //ӱ־
            printf( "HUB 1 dev in\n" );
            s = ERR_USB_CONNECT;
        }
    }
    else if ( RootHubDev[1].DeviceStatus >= ROOT_DEV_CONNECTED )//⵽豸γ
    {
        DisableRootHubPort( 1 );                                // رն˿
        //UH_SETUP &= ~bUH_SOF_EN;
        printf( "HUB 1 dev out\n" );
        if ( s == ERR_SUCCESS )
        {
            s = ERR_USB_DISCON;
        }
    }
//  UIF_DETECT = 0;                                             // жϱ־
    return( s );
}
/*******************************************************************************
* Function Name  : SetHostUsbAddr
* Description    : USBǰUSB豸ַ
* Input          : UINT8 addr
* Output         : None
* Return         : None
*******************************************************************************/
void    SetHostUsbAddr( UINT8 addr )
{
    USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | addr & 0x7F;
}
/*******************************************************************************
* Function Name  : SetUsbSpeed
* Description    : õǰUSBٶ
* Input          : UINT8 FullSpeed
* Output         : None
* Return         : None
*******************************************************************************/
void    SetUsbSpeed( UINT8 FullSpeed )
{
    if ( FullSpeed )                                            // ȫ
    {
        USB_CTRL &= ~ bUC_LOW_SPEED;                            // ȫ
        UH_SETUP &= ~ bUH_PRE_PID_EN;                           // ֹPRE PID
    }
    else
    {
        USB_CTRL |= bUC_LOW_SPEED;                              // 
    }
}
/*******************************************************************************
* Function Name  : ResetRootHubPort( UINT8 RootHubIndex )
* Description    : ⵽豸,λ,Ϊö豸׼,ΪĬΪȫ
* Input          : UINT8 RootHubIndex ָ˿
* Output         : None
* Return         : None
*******************************************************************************/
UINT8   ResetRootHubPort( UINT8 RootHubIndex )
{
    UINT16 n = 30000;
	UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;                        //USB豸Ķ˵0ߴ
    SetHostUsbAddr( 0x00 );	
    SetUsbSpeed( 1 );                                            // ĬΪȫ
    if ( RootHubIndex == 1 )
    {
        UHUB1_CTRL = UHUB1_CTRL & ~ bUH_LOW_SPEED | bUH_BUS_RESET;// ĬΪȫ,ʼλ
		while( n )
		{
			++ SAFE_MOD;  												
			++ SAFE_MOD;
			++ SAFE_MOD;
			++ SAFE_MOD;
			++ SAFE_MOD;
			++ SAFE_MOD;
			++ SAFE_MOD;
			++ SAFE_MOD;
			++ SAFE_MOD;
			if( USB_HUB_ST & ( bUHS_HP_PIN | bUHS_HM_PIN ) )
			{
				UHUB1_CTRL = UHUB1_CTRL & ~bUH_BUS_RESET;  						/* λ */
				return( 0x01 );
			}
			--n;
		}
        UHUB1_CTRL = UHUB1_CTRL & ~ bUH_BUS_RESET;               // λ
    }
    else
    {
        UHUB0_CTRL = UHUB0_CTRL & ~ bUH_LOW_SPEED | bUH_BUS_RESET;// ĬΪȫ,ʼλ
        while( n ) 
		{  
			++ SAFE_MOD;  												
			++ SAFE_MOD;
			++ SAFE_MOD;
			++ SAFE_MOD;
			++ SAFE_MOD;
			++ SAFE_MOD;
			++ SAFE_MOD;
			++ SAFE_MOD;
			++ SAFE_MOD;
			if( USB_HUB_ST & ( bUHS_DP_PIN | bUHS_DM_PIN ) )
			{
				UHUB0_CTRL = UHUB0_CTRL & ~bUH_BUS_RESET;  						/* λ */
				return( 0x01 );
			}
			-- n;
		}
        UHUB0_CTRL = UHUB0_CTRL & ~ bUH_BUS_RESET;               // λ
    }
    mDelayuS( 200 );
    UIF_DETECT = 0;											     // жϱ־
	return ( 0x00 );
}
/*******************************************************************************
* Function Name  : EnableRootHubPort( UINT8 RootHubIndex )
* Description    : ʹROOT-HUB˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ
* Input          : UINT8 RootHubIndex ָ˿
* Output         : None
* Return         : ERR_SUCCESSΪ⵽,ERR_USB_DISCONΪ
*******************************************************************************/
UINT8   EnableRootHubPort( UINT8 RootHubIndex )
{
    if ( RootHubDev[ RootHubIndex ].DeviceStatus < ROOT_DEV_CONNECTED )
    {
        RootHubDev[ RootHubIndex ].DeviceStatus = ROOT_DEV_CONNECTED;
    }
    if ( RootHubIndex == 1 )
    {
        if ( USB_HUB_ST & bUHS_H1_ATTACH )                       // HUB1豸
        {
            if ( ( UHUB1_CTRL & bUH_PORT_EN ) == 0x00 )          // δʹ
            {
                RootHubDev[1].DeviceSpeed = USB_HUB_ST & bUHS_HM_LEVEL ? 0 : 1;
                if ( RootHubDev[1].DeviceSpeed == 0 )
                {
                    UHUB1_CTRL |= bUH_LOW_SPEED;                 // 
                }
            }
            UHUB1_CTRL |= bUH_PORT_EN;                           //ʹHUB1˿
            return( ERR_SUCCESS );
        }
    }
    else
    {
        if ( USB_HUB_ST & bUHS_H0_ATTACH )                      // HUB0豸
        {
            if ( ( UHUB0_CTRL & bUH_PORT_EN ) == 0x00 )         // δʹ
            {
                RootHubDev[0].DeviceSpeed = USB_HUB_ST & bUHS_DM_LEVEL ? 0 : 1;
                if ( RootHubDev[0].DeviceSpeed == 0 )
                {
                    UHUB0_CTRL |= bUH_LOW_SPEED;                // 
                }
            }
            UHUB0_CTRL |= bUH_PORT_EN;                          //ʹHUB0˿
            return( ERR_SUCCESS );
        }
    }
    return( ERR_USB_DISCON );
}
/*******************************************************************************
* Function Name  : SelectHubPort( UINT8 RootHubIndex, UINT8 HubPortIndex )
* Description    : ѡҪHUB
* Input          : UINT8 RootHubIndex HubPortIndex=0ѡָROOT-HUB˿,ѡָROOT-HUB˿ڵⲿHUBָ˿
                   UINT8 HubPortIndex ѡָROOT-HUB˿ڵⲿHUBָ˿
* Output         : None
* Return         : None
*******************************************************************************/
void  SelectHubPort( UINT8 RootHubIndex, UINT8 HubPortIndex )
{
    UINT8 i;
    i = HubPortIndex;
    SetHostUsbAddr( RootHubDev[RootHubIndex].DeviceAddress );// USBǰUSB豸ַ
    SetUsbSpeed( RootHubDev[RootHubIndex].DeviceSpeed );     // õǰUSBٶ
    RootHubId = RootHubIndex ? 1 : 0;
}

/*******************************************************************************
* Function Name  : USBHostTransact
* Description    : CH559,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
                   ӳ,ʵӦ,Ϊṩٶ,ӦöԱӳŻ
* Input          : UINT8 endp_pid ƺ͵ַ  endp_pid: 4λtoken_pid, 4λǶ˵ַ
                   UINT8 tog      ͬ־
                   UINT16 timeout ʱʱ
* Output         : None
* Return         : ERR_USB_UNKNOWN ʱӲ쳣
                   ERR_USB_DISCON  豸Ͽ
                   ERR_USB_CONNECT 豸
                   ERR_SUCCESS     
*******************************************************************************/
UINT8   USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT16 timeout )
{
    UINT8   TransRetry;
    UINT8   r;
    UINT16  i;
    UH_RX_CTRL = tog;
    UH_TX_CTRL =tog ;
    TransRetry = 0;
    do
    {
        UH_EP_PID = endp_pid;                                    // ָPIDĿĶ˵
        UIF_TRANSFER = 0;                                        // 
        for ( i = WAIT_USB_TOUT_200US; i != 0 && UIF_TRANSFER == 0; i -- )
        {
            ;
        }
        UH_EP_PID = 0x00;                                        // ֹͣUSB
        if ( UIF_TRANSFER == 0 )
        {
            return( ERR_USB_UNKNOWN );
        }
        if ( UIF_TRANSFER )                                      // 
        {
            if ( U_TOG_OK )
            {
                return( ERR_SUCCESS );
            }
            r = USB_INT_ST & MASK_UIS_H_RES;                     // USB豸Ӧ״̬
            if ( r == USB_PID_STALL )
            {
                return( r | ERR_USB_TRANSFER );
            }
            if ( r == USB_PID_NAK )
            {
                if ( timeout == 0 )
                {
                    return( r | ERR_USB_TRANSFER );
                }
                if ( timeout < 0xFFFF )
                {
                    timeout --;
                }
                -- TransRetry;
            }
            else switch ( endp_pid >> 4 )
                {
                case USB_PID_SETUP:
                case USB_PID_OUT:
                    if ( U_TOG_OK )
                    {
                        return( ERR_SUCCESS );
                    }
                    if ( r == USB_PID_ACK )
                    {
                        return( ERR_SUCCESS );
                    }
                    if ( r == USB_PID_STALL || r == USB_PID_NAK )
                    {
                        return( r | ERR_USB_TRANSFER );
                    }
                    if ( r )
                    {
                        return( r | ERR_USB_TRANSFER );          // ǳʱ/,Ӧ
                    }
                    break;                                       // ʱ
                case USB_PID_IN:
                    if ( U_TOG_OK )
                    {
                        return( ERR_SUCCESS );
                    }
                    if ( tog ? r == USB_PID_DATA1 : r == USB_PID_DATA0 )
                    {
                        return( ERR_SUCCESS );
                    }
                    if ( r == USB_PID_STALL || r == USB_PID_NAK )
                    {
                        return( r | ERR_USB_TRANSFER );
                    }
                    if ( r == USB_PID_DATA0 && r == USB_PID_DATA1 )// ͬ趪
                    {
                    }                                            // ͬ
                    else if ( r )
                    {
                        return( r | ERR_USB_TRANSFER );          // ǳʱ/,Ӧ
                    }
                    break;                                       // ʱ
                default:
                    return( ERR_USB_UNKNOWN );                   // ܵ
                    break;
                }
        }
        else                                                     // ж,Ӧ÷
        {
            USB_INT_FG = 0xFF;                                   //жϱ־
        }
        mDelayuS( 15 );
    }
    while ( ++ TransRetry < 3 );
    return( ERR_USB_TRANSFER );                                  // Ӧʱ
}
/*******************************************************************************
* Function Name  : HostCtrlTransfer
* Description    : ִпƴ,8ֽpSetupReq,DataBufΪѡշ
* Input          : PUINT8X DataBuf Ҫպͷ,ôDataBufָЧڴź
                   PUINT8 RetLen  ʵʳɹշܳȱRetLenָֽڱ
* Output         : None
* Return         : ERR_USB_BUF_OVER IN״̬׶γ
                   ERR_SUCCESS     ݽɹ
                   ״̬
*******************************************************************************/
UINT8   HostCtrlTransfer( PUINT8 DataBuf, PUINT8 RetLen )
{
    UINT16  RemLen  = 0;
    UINT8   s, RxLen, RxCnt, TxCnt;
    PUINT8  pBuf;
    PUINT8  xdata   pLen;
    pBuf = DataBuf;
    pLen = RetLen;
    mDelayuS( 200 );
    if ( pLen )
    {
        *pLen = 0;                                                // ʵʳɹշܳ
    }
    UH_TX_LEN = sizeof( USB_SETUP_REQ );
    s = USBHostTransact( USB_PID_SETUP << 4 | 0x00, 0x00, 200000/20 );// SETUP׶,200mSʱ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    UH_RX_CTRL = UH_TX_CTRL = bUH_R_TOG | bUH_R_AUTO_TOG | bUH_T_TOG | bUH_T_AUTO_TOG;// ĬDATA1
    UH_TX_LEN = 0x01;                                            // Ĭݹ״̬׶ΪIN
    RemLen = (pSetupReq -> wLengthH << 8)|( pSetupReq -> wLengthL);
    if ( RemLen && pBuf )                                        // Ҫշ
    {
        if ( pSetupReq -> bRequestType & USB_REQ_TYP_IN )        // 
        {
            while ( RemLen )
            {
                mDelayuS( 200 );
                s = USBHostTransact( USB_PID_IN << 4 | 0x00, UH_RX_CTRL, 200000/20 );// IN
                if ( s != ERR_SUCCESS )
                {
                    return( s );
                }
                RxLen = USB_RX_LEN < RemLen ? USB_RX_LEN : RemLen;
                RemLen -= RxLen;
                if ( pLen )
                {
                    *pLen += RxLen;                             // ʵʳɹշܳ
                }
                for ( RxCnt = 0; RxCnt != RxLen; RxCnt ++ )
                {
                    *pBuf = RxBuffer[ RxCnt ];
                    pBuf ++;
                }
                if ( USB_RX_LEN == 0 || ( USB_RX_LEN & ( UsbDevEndp0Size - 1 ) ) )
                {
                    break;                                      // ̰
                }
            }
            UH_TX_LEN = 0x00;                                   // ״̬׶ΪOUT
        }
        else                                                    // 
        {
            while ( RemLen )
            {
                mDelayuS( 200 );
                UH_TX_LEN = RemLen >= UsbDevEndp0Size ? UsbDevEndp0Size : RemLen;
                for ( TxCnt = 0; TxCnt != UH_TX_LEN; TxCnt ++ )
                {
                    TxBuffer[ TxCnt ] = *pBuf;
                    pBuf ++;
                }
                s = USBHostTransact( USB_PID_OUT << 4 | 0x00, UH_TX_CTRL, 200000/20 );// OUT
                if ( s != ERR_SUCCESS )
                {
                    return( s );
                }
                RemLen -= UH_TX_LEN;
                if ( pLen )
                {
                    *pLen += UH_TX_LEN;                        // ʵʳɹշܳ
                }
            }
        }
    }
    mDelayuS( 200 );
    s = USBHostTransact( ( UH_TX_LEN ? USB_PID_IN << 4 | 0x00: USB_PID_OUT << 4 | 0x00 ), bUH_R_TOG | bUH_T_TOG, 200000/20 );  // STATUS׶
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( UH_TX_LEN == 0 )
    {
        return( ERR_SUCCESS );                                  // ״̬OUT
    }
    if ( USB_RX_LEN == 0 )
    {
        return( ERR_SUCCESS );                                  // ״̬IN,IN״̬ݳ
    }
    return( ERR_USB_BUF_OVER );                                 // IN״̬׶δ
}
/*******************************************************************************
* Function Name  : CopySetupReqPkg
* Description    : ƿƴ
* Input          : PUINT8C pReqPkt ַ
* Output         : None
* Return         : None
*******************************************************************************/
void    CopySetupReqPkg( PUINT8C pReqPkt )                      // ƿƴ
{
    UINT8   i;
    for ( i = 0; i != sizeof( USB_SETUP_REQ ); i ++ )
    {
        ((PUINT8X)pSetupReq)[ i ] = *pReqPkt;
        pReqPkt ++;
    }
}
/*******************************************************************************
* Function Name  : CtrlGetDeviceDescr
* Description    : ȡ豸,TxBuffer
* Input          : None
* Output         : None
* Return         : ERR_USB_BUF_OVER ȴ
                   ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlGetDeviceDescr( void )
{
    UINT8   s;
    UINT8   len;
    UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;
    CopySetupReqPkg( SetupGetDevDescr );
    s = HostCtrlTransfer( TxBuffer, &len );                    // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    UsbDevEndp0Size = ( (PXUSB_DEV_DESCR)TxBuffer ) -> bMaxPacketSize0;// ˵0,Ǽ򻯴,ӦȻȡǰ8ֽںUsbDevEndp0Sizeټ
    if ( len < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL )
    {
        return( ERR_USB_BUF_OVER );                            // ȴ
    }
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : CtrlGetConfigDescr
* Description    : ȡ,TxBuffer
* Input          : None
* Output         : None
* Return         : ERR_USB_BUF_OVER ȴ
                   ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlGetConfigDescr( void )
{
    UINT8   s;
    UINT8D  len;
    CopySetupReqPkg( SetupGetCfgDescr );
    s = HostCtrlTransfer( TxBuffer, &len );                     // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < ( (PUSB_SETUP_REQ)SetupGetCfgDescr ) -> wLengthL )
    {
        return( ERR_USB_BUF_OVER );                             // سȴ
    }
    len = ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL;
    CopySetupReqPkg( SetupGetCfgDescr );
    pSetupReq -> wLengthL = len;                                // ܳ
    s = HostCtrlTransfer( TxBuffer, &len );                     // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    if ( len < ( (PUSB_SETUP_REQ)SetupGetCfgDescr ) -> wLengthL || len < ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL )
    {
        return( ERR_USB_BUF_OVER );                             // ȴ
    }
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : CtrlSetUsbAddress
* Description    : USB豸ַ
* Input          : UINT8 addr 豸ַ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlSetUsbAddress( UINT8 addr )
{
    UINT8   s;
    CopySetupReqPkg( SetupSetUsbAddr );
    pSetupReq -> wValueL = addr;                                 // USB豸ַ
    s = HostCtrlTransfer( NULL, NULL );                          // ִпƴ
    if ( s != ERR_SUCCESS )
    {
        return( s );
    }
    SetHostUsbAddr( addr );                                      // USBǰUSB豸ַ
    mDelaymS( 10 );                                              // ȴUSB豸ɲ
    return( ERR_SUCCESS );
}
/*******************************************************************************
* Function Name  : CtrlSetUsbConfig
* Description    : USB豸
* Input          : UINT8 cfg       ֵ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlSetUsbConfig( UINT8 cfg )
{
    CopySetupReqPkg( SetupSetUsbConfig );
    pSetupReq -> wValueL = cfg;                                 // USB豸
    return( HostCtrlTransfer( NULL, NULL ) );                   // ִпƴ
}
/*******************************************************************************
* Function Name  : CtrlSetUsbIDLE
* Description    : USB豸
* Input          : UINT8 cfg       ֵ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlSetUsbIDLE( UINT8 idle )
{
    CopySetupReqPkg( SetupSetUsbIDLE );
    pSetupReq -> wIndexL = idle;                                 // USB豸
    return( HostCtrlTransfer( NULL, NULL ) );                   // ִпƴ
}

/*******************************************************************************
* Function Name  : CtrlClearEndpStall
* Description    : ˵STALL
* Input          : UINT8 endp       ˵ַ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8   CtrlClearEndpStall( UINT8 endp )
{
    CopySetupReqPkg( SetupClrEndpStall );                       // ˵Ĵ
    pSetupReq -> wIndexL = endp;                                // ˵ַ
    return( HostCtrlTransfer( NULL, NULL ) );                   // ִпƴ
}
/*******************************************************************************
* Function Name  : CtrlGetHIDDeviceReport
* Description    : ȡHID
* Input          : UINT8 Len  
                   UINT8 IfNum ӿڱ
* Output         : None
* Return         : ERR_SUCCESS      ɹ
                   
*******************************************************************************/
UINT8	CtrlGetHIDDeviceReport(UINT16 Len,UINT8 IfNum)
{
    CopySetupReqPkg( SetupGetHIDDevReport );                      // ȡӿڱ
    ((PUINT8X)pSetupReq)[ 6 ] = Len + 0x40;                       //+0x40
    ((PUINT8X)pSetupReq)[ 7 ] = (Len + 0x40)>>8;                  //
    ((PUINT8X)pSetupReq)[ 4 ] = IfNum;                            //
	return( HostCtrlTransfer( TxBuffer, NULL ) );                   // ִпƴ
}
/*******************************************************************************
* Function Name  : KM_HostSetReport
* Description    : USB豸
* Input          : UINT8 cfg       ֵ
* Output         : None
* Return         :
*******************************************************************************/
void	KM_HostSetReport( UINT8 cfg )  // USB豸
{
	CopySetupReqPkg( SetupSetReport );
	HostCtrlTransfer( &cfg, NULL );  // ִпƴ
}

UINT8 KM_HostAnalyseMouseHid( UINT8 index, UINT8 num ) 
{
	if( ((UINT8 *)TxBuffer)[0] == GLOB_USAGE_PAGE_DEF && ((UINT8 *)TxBuffer)[1] == GLOB_USAGE_PAGE_DESKTOP\
	 && ((UINT8 *)TxBuffer)[2] == LOCAL_USAGE_DEF && ((UINT8 *)TxBuffer)[3] == LOCAL_USAGE_MOUSE ){
			RootHubDev[index].Interface[num].DeviceType = DEV_TYPE_MOUSE;
		  return ERR_SUCCESS;		 
		}
	  else if( ((UINT8 *)TxBuffer)[0] == GLOB_USAGE_PAGE_DEF && ((UINT8 *)TxBuffer)[1] == GLOB_USAGE_PAGE_DESKTOP\
	 && ((UINT8 *)TxBuffer)[2] == LOCAL_USAGE_DEF && ((UINT8 *)TxBuffer)[3] == LOCAL_USAGE_KEY ){
			RootHubDev[index].Interface[num].DeviceType = DEV_TYPE_KEYBOARD;
			return ERR_SUCCESS;
		}
	return ERR_USB_UNSUPPORT;
}

/*******************************************************************************
* Function Name  : InitRootDevice
* Description    : ʼָROOT-HUB˿ڵUSB豸
* Input          : UINT8 RootHubIndex ָ˿ڣHUB˿ں0/1
* Output         : None
* Return         :
*******************************************************************************/
UINT8   InitRootDevice( UINT8 RootHubIndex )
{
    UINT8   i, s, cfg, dv_cls, if_cls,ep;
    UINT8  retry=0;
    printf( "Reset root hub %1d# port\n", (UINT16)RootHubIndex );
    while(retry<10)
    {
        mDelaymS( 100*retry );
        retry++;
        ResetRootHubPort( RootHubIndex );                    // ⵽豸,λӦ˿ڵUSB
        for ( i = 0, s = 0; i < 100; i ++ )                            // ȴUSB豸λ,100mSʱ
        {
            mDelaymS( 1 );
            if ( EnableRootHubPort( RootHubIndex ) == ERR_SUCCESS )    // ʹROOT-HUB˿
            {
                i = 0;
                s ++;                                                  // ʱȴUSB豸Ӻȶ
                if ( s > 10*retry )
                {
                    break;                                             // Ѿȶ15mS
                }
            }
        }
        if ( i )                                                       // λ豸û
        {
            DisableRootHubPort( RootHubIndex );
            printf( "Disable root hub %1d# port because of disconnect\n", (UINT16)RootHubIndex );
//         return( ERR_USB_DISCON );
            continue;
        }
        SelectHubPort( RootHubIndex, 0 );
        printf( "GetDevDescr: " );
        s = CtrlGetDeviceDescr( );                                     // ȡ豸
        if ( s == ERR_SUCCESS )
        {
            for ( i = 0; i < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL; i ++ )
            {
                printf( "x%02X ", (UINT16)( TxBuffer[i] ) );
            }
            printf( "\n" );                                            // ʾ
            dv_cls = ( (PXUSB_DEV_DESCR)TxBuffer ) -> bDeviceClass;    // 豸
            s = CtrlSetUsbAddress( RootHubIndex + ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL );// USB豸ַ,RootHubIndexԱ֤2HUB˿ڷ䲻ͬĵַ
            if ( s == ERR_SUCCESS )
            {
                RootHubDev[RootHubIndex].DeviceAddress = RootHubIndex + ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL;  // USBַ
                printf( "GetCfgDescr: " );
                s = CtrlGetConfigDescr( );                             // ȡ
				if ( s == ERR_SUCCESS ){
					RootHubDev[RootHubIndex].InfCnt = ((PXUSB_CFG_DESCR)TxBuffer)->bNumInterfaces;//ӿ
					if( RootHubDev[RootHubIndex].InfCnt > 4 ) return( ERR_USB_OVER_IF );          //4ӿ
					cfg = ( (PXUSB_CFG_DESCR)TxBuffer ) -> bConfigurationValue;
#ifdef DEBUG
					printf( "ifnum %02X ", (UINT16)RootHubDev[RootHubIndex].InfCnt );
					for ( i = 0; i < ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL; i ++ ){
							printf( "x%02X ", (UINT16)( TxBuffer[i] ) );
					}
					printf("\n");
#endif
					//,ȡ˵/˵ַ/˵С,±endp_addrendp_size
					if_cls = ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceClass;  // ӿ 03
					if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_HID && ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceSubClass <= 0x01 )// HID豸,/
					{
						s = 0;									
						for(i=0;i<RootHubDev[RootHubIndex].InfCnt;i++){  
							if(TxBuffer[s+1] == 0x02){//										
								s = s	+ TxBuffer[s];
							}										
							if(TxBuffer[s+1] == 0x04){//ӿ	
								ep = TxBuffer[s+4];											
								s = s	+ TxBuffer[s];								
							}									
							if(TxBuffer[s+1] == 0x21){//HID										
								s = s	+ TxBuffer[s];
								RootHubDev[RootHubIndex].Interface[i].DescrLen = TxBuffer[s-1];
								RootHubDev[RootHubIndex].Interface[i].DescrLen <<= 8;
								RootHubDev[RootHubIndex].Interface[i].DescrLen |= TxBuffer[s-2]; // 												
							}			
							if(TxBuffer[s+1] == 0x05){//˵		
								 while(ep--){										
									 if(TxBuffer[s+2]&0x80){//IN
										RootHubDev[RootHubIndex].Interface[i].InAddr = TxBuffer[s+2]&0x0f;	
										RootHubDev[RootHubIndex].Interface[i].WaitUSB_IN_Interval = TxBuffer[s+6];
										if((RootHubDev[RootHubIndex].DeviceSpeed == 0)&&(RootHubDev[RootHubIndex].Interface[i].WaitUSB_IN_Interval<8))
										{
										  RootHubDev[RootHubIndex].Interface[i].WaitUSB_IN_Interval	= 8;														
										}															
#ifdef DEBUG
										printf( "IN_Ep %02X \n", (UINT16)( RootHubDev[RootHubIndex].Interface[i].InAddr ) );
										printf( "IN_Val %02X \n", (UINT16)( RootHubDev[RootHubIndex].Interface[i].WaitUSB_IN_Interval ) );													 
#endif															 
										s = s	+ TxBuffer[s];													 
										continue;											 
									 }											 
									 if((TxBuffer[s+2]&0x80)==0){//OUT
										RootHubDev[RootHubIndex].Interface[i].OutAddr = TxBuffer[s+2]&0x0f;	
										s = s	+ TxBuffer[s];	
										continue;											  
									 }
								}										  
							}					
#ifdef DEBUG
							printf( "hidlen %02X ", (UINT16)( RootHubDev[RootHubIndex].Interface[i].DescrLen ) );
							printf("\n");
#endif											
						}
						s = CtrlSetUsbConfig( cfg );                   // USB豸
						if ( s == ERR_SUCCESS )
						{
							for(i=0;i<RootHubDev[RootHubIndex].InfCnt;i++){
								CtrlSetUsbIDLE(i);													
								s = CtrlGetHIDDeviceReport(RootHubDev[RootHubIndex].Interface[i].DescrLen,i);              //ȡ
#ifdef DEBUG	
								printf( "len003 %02X \n", (UINT16)(RootHubDev[RootHubIndex].Interface[i].DescrLen) );
								
								for ( cfg=0; cfg<(RootHubDev[RootHubIndex].Interface[i].DescrLen); cfg++ ){
									printf( "x%02X ", (UINT16)( TxBuffer[cfg] ) );
								}
								printf("\n");
								printf( "GetHIDReport: %02X ", (UINT16)s );
#endif
								if( s == ERR_SUCCESS ){
									s = KM_HostAnalyseMouseHid( RootHubIndex, i );// Ҫ
								}
								else return s;
							}
							if((RootHubDev[0].Interface[0].DeviceType == DEV_TYPE_KEYBOARD)&&(RootHubDev[1].Interface[0].DeviceType == DEV_TYPE_KEYBOARD)){//2
								KM_HostSetReport(ReportData);//ͬLED										
							}	
							RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_SUCCESS;												
							return( ERR_SUCCESS );                    
						}
					}
					else                                                                  //豸
					{
						s = CtrlSetUsbConfig( cfg );                   // USB豸
						if ( s == ERR_SUCCESS )
						{					
							RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_SUCCESS;
							RootHubDev[RootHubIndex].DeviceType = dv_cls?dv_cls:if_cls;
							return( ERR_SUCCESS ); 
						}
					}
                }
            }
        }
        printf( "InitRootDev Err = %02X\n", (UINT16)s );
        RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_FAILED;
        SetUsbSpeed( 1 );                                                                 // ĬΪȫ
        continue;
    }
    return( s );
}
/*******************************************************************************
* Function Name  : EnumAllRootDevice
* Description    : öROOT-HUB˿ڵUSB豸
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8   EnumAllRootDevice( void )
{
    UINT8I   s, RootHubIndex;
    printf( "EnumAllRootDev\n" );
    for ( RootHubIndex = 0; RootHubIndex < 2; RootHubIndex ++ )
    {
        printf( "RootHubIndex %02x\n",(UINT16)RootHubIndex );
        if ( RootHubDev[RootHubIndex].DeviceStatus == ROOT_DEV_CONNECTED )           // ղ豸δʼ
        {
            s = InitRootDevice( RootHubIndex );                                      // ʼ/öָHUB˿ڵUSB豸
            if ( s != ERR_SUCCESS )
            {
                return( s );
            }
        }
    }
    return( ERR_SUCCESS );
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void    mInitSTDIO( void )
{
//  SCON = 0x50;
    SM0 = 0;
    SM1 = 1;
    SM2 = 0;
    REN = 1;
    PCON |= SMOD;
    TMOD = TMOD & ~ bT1_GATE & ~ bT1_CT & ~ MASK_T1_MOD | bT1_M1;                    // 0X20
    T2MOD = T2MOD | bTMR_CLK | bT1_CLK;                                              // *12
    TH1 = 0-13;//0xF3;                                                               /* 12MHz, 4800bps*12=57600bps */
    TR1 = 1;
    TI = 1;
}
/*******************************************************************************
* Function Name  : InitUSB_Host
* Description    : ʼUSBѯʽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void    InitUSB_Host( void )
{
    UINT8   i;
    IE_USB = 0;
    USB_CTRL = bUC_HOST_MODE;                                                       // 趨ģʽ
    USB_DEV_AD = 0x00;
    UH_EP_MOD = bUH_EP_TX_EN | bUH_EP_RX_EN ;
    UH_RX_DMA = RxBuffer;
    UH_TX_DMA = TxBuffer;
    UH_RX_CTRL = 0x00;
    UH_TX_CTRL = 0x00;
    USB_CTRL = bUC_HOST_MODE | bUC_INT_BUSY | bUC_DMA_EN;                           // USBDMA,жϱ־δǰԶͣ
    UH_SETUP = bUH_SOF_EN;
    USB_INT_FG = 0xFF;                                                              // жϱ־
    for ( i = 0; i != 2; i ++ )
    {
        DisableRootHubPort( i );                                                    // 
    }
    USB_INT_EN = bUIE_TRANSFER | bUIE_DETECT;
}

/*******************************************************************************
* Function Name  : RootHUB_Detect_USB_Plug
* Description    : ROOTHUB˿豸
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void RootHUB_Detect_USB_Plug( void )
{
	UINT8 s;
	s = ERR_SUCCESS;
	if ( UIF_DETECT )                                                           // USBж
	{
		UIF_DETECT = 0;                                                         // жϱ־
		s = AnalyzeRootHub( );                                                  // ROOT-HUB״̬
		if ( s == ERR_USB_CONNECT )
		{
				FoundNewDev = 1;
		}
	}	
}
/*******************************************************************************
* Function Name  : RootHUB_USB_Dev_Enum
* Description    : öROOT HUB dev
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void RootHUB_USB_Dev_Enum( void )
{
	UINT8 s;
	s = ERR_SUCCESS;	
	if ( FoundNewDev )                                                          // µUSB豸
	{
		FoundNewDev = 0;
		mDelaymS( 200 );                                                        // USB豸ղδȶ,ʵȴUSB豸ٺ,ζ
		s = EnumAllRootDevice( );                                               // öROOT-HUB˿ڵUSB豸
		if ( s != ERR_SUCCESS )
		{
			printf( "EnumAllRootDev err = %02X\n", (UINT16)s );
		}
	}	
}

/*******************************************************************************
* Function Name  : RootHUB_Get_Mouse_Data
* Description    : ȡROOT HUB¼
* Input          : 
                   UINT8 RootHubIndex
                   UINT8 Dev_Type
                   PUINT8 MPort0 HUB0ݣPUINT8 MPort1 HUB1
                   MPortn Ϊ0û
* Output         : None
* Return         : None 
*******************************************************************************/
void RootHUB_Get_Data( UINT8 RootHubIndex,UINT8 Dev_Type,PUINT8 MPort0, PUINT8 MPort1)
{
	UINT8 s,endp,i,flag;
	flag = 0;
	if((Dev_Type == DEV_TYPE_KEYBOARD)||(Dev_Type == DEV_TYPE_MOUSE))
	{
		for(i=0;i<RootHubDev[RootHubIndex].InfCnt;i++)
		{		
			if ( RootHubDev[RootHubIndex].Interface[i].DeviceType == Dev_Type && RootHubDev[RootHubIndex].DeviceStatus >= ROOT_DEV_SUCCESS  && T0Count[RootHubIndex][i] >= RootHubDev[RootHubIndex].Interface[i].WaitUSB_IN_Interval)
			{
				T0Count[RootHubIndex][i] = 0;                                              //ռʱ				
				SelectHubPort( RootHubIndex, 0 );                                           // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
				endp = RootHubDev[RootHubIndex].Interface[i].InAddr;                        // ж϶˵ĵַ,λ7ͬ־λ
				if ( endp & USB_ENDP_ADDR_MASK )                                            // ˵Ч
				{
					s = USBHostTransact( USB_PID_IN << 4 | endp & 0x7F, endp & 0x80 ? bUH_R_TOG | bUH_T_TOG : 0, 0 );// CH559,ȡ,NAK
					if ( s == ERR_SUCCESS )
					{
						endp ^= 0x80;                                                           // ͬ־ת
						RootHubDev[RootHubIndex].Interface[i].InAddr = endp;                                                  
						if ( USB_RX_LEN )                                                       // յݳ
						{								
							if(RootHubIndex)
							{
								MPort1[0] = USB_RX_LEN;									
								memcpy(MPort1+1,RxBuffer,USB_RX_LEN);                               //HUB1	
							}									
							else
							{
								MPort0[0] = USB_RX_LEN;									
								memcpy(MPort0+1,RxBuffer,USB_RX_LEN);                               //HUB0
							}
							if(Dev_Type == DEV_TYPE_KEYBOARD)
							{									
											if(RxBuffer[2]==0x39){//Caps Lock		
												ReportData ^= 0x02;			
												KM_HostSetReport(ReportData);	
												flag = 0xAA;
											}
											if(RxBuffer[2]==0x53){//Num Lock		
												ReportData ^= 0x01;		
												KM_HostSetReport(ReportData);					
												flag = 0xAA;					
											}		
											if(RxBuffer[2]==0x47){//Scroll Lock		
												ReportData ^= 0x04;		
												KM_HostSetReport(ReportData);					
												flag = 0xAA;					
											}
											if((flag == 0xAA)&&(RootHubDev[0].Interface[0].DeviceType == DEV_TYPE_KEYBOARD)&&(RootHubDev[1].Interface[0].DeviceType == DEV_TYPE_KEYBOARD)){//2	
												s = RootHubIndex ^ 0x01;	
												SelectHubPort(s,0);	// switch hub num			
												KM_HostSetReport(ReportData);							
											}								
						   }							
						   return;                                                               //ͬһHUB˿ڸ϶ֻȡ1豸ӿ						
						}
					}			
				 }
			 }
		  }		
	}
}
/*******************************************************************************
* Function Name  : main
* Description    : main
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
main( )
{
    UINT8   i;
    UINT8   RootHub0[20];
    UINT8   RootHub1[20];	
    mInitSTDIO( );                                                                  //Ϊüͨڼʾ
    printf("CHIP_ID: %02x\n",(UINT16)ID_CH559);
	printf("Host_Keyboard_Mouse_V100:"__DATE__",Debug time:"__TIME__"\n");
    InitUSB_Host( );                                                                //ʼUSB
    mTimer0ClkFsys( );                                                              //öʱ0 1msʱ
    mTimer0ModSetup( 1 );
    mTimer0SetData( WAIT_USB_IN_COUNT );
    mTimer0RunCTL(T0_START);	
	
	
    FoundNewDev = 0;                                                                //ʼ
    memset(RootHubDev,0,sizeof(RootHubDev));
    memset(T0Count,0,sizeof(T0Count));	
	
    while ( 1 )
    {
		RootHUB_Detect_USB_Plug( );                                              //豸			
		RootHUB_USB_Dev_Enum( );                                                 //öROOT豸
		
		RootHubId = 0;					
		memset(RootHub0,0,sizeof(RootHub0));
		memset(RootHub1,0,sizeof(RootHub1));			
		RootHUB_Get_Data( RootHubId,DEV_TYPE_MOUSE,RootHub0,RootHub1);
		if(RootHub0[0])                                                         //HUB0 Mouse
		{
			printf("HUB0_Mouse data: ");
			for ( i = 1; i <= RootHub0[0]; i ++ )
			{
					printf("x%02X ",(UINT16)(RootHub0[i]) );
			}
			printf("\n");					
		}
		memset(RootHub0,0,sizeof(RootHub0));
		memset(RootHub1,0,sizeof(RootHub1));						
		RootHUB_Get_Data( RootHubId,DEV_TYPE_KEYBOARD,RootHub0,RootHub1);
		if(RootHub0[0])                                                         //HUB0 Keyboard
		{
			printf("HUB0_Keyboard data: ");
			for ( i = 1; i <= RootHub0[0]; i ++ )
			{
					printf("x%02X ",(UINT16)(RootHub0[i]) );
			}
			printf("\n");					
		}					
		RootHubId = 1;					
		memset(RootHub0,0,sizeof(RootHub0));
		memset(RootHub1,0,sizeof(RootHub1));			
		RootHUB_Get_Data( RootHubId,DEV_TYPE_MOUSE,RootHub0,RootHub1);			
		if(RootHub1[0])                                                         //HUB1 Mouse
		{
			printf("HUB1_Mouse data: ");
			for ( i = 1; i <= RootHub1[0]; i ++ )
			{
					printf("x%02X ",(UINT16)(RootHub1[i]) );
			}
			printf("\n");					
		}		
		memset(RootHub0,0,sizeof(RootHub0));
		memset(RootHub1,0,sizeof(RootHub1));						
		RootHUB_Get_Data( RootHubId,DEV_TYPE_KEYBOARD,RootHub0,RootHub1);			
		if(RootHub1[0])                                                         //HUB1 Keyboard
		{
			printf("HUB1_Keyboard data: ");
			for ( i = 1; i <= RootHub1[0]; i ++ )
			{
					printf("x%02X ",(UINT16)(RootHub1[i]) );
			}
			printf("\n");					
		}		
				
		SetUsbSpeed( 1 );                                                        // ĬΪȫ		
		mTimer0Interrupt( );                                                     // 1msʱ				
    }
}
